!
!        CHECK FOR VALID DATE   -   CJH
!        NOTE: ACCEPTABLE FORMATS INCLUDE:
!              MMDDYY, MMDDYYYY, MM/DD/YY, MM/DD/YYYY
!              MM.DD.YY, MM-DD-YY

CKDATE:
     LET DTERR = 0                                     ! RESET ERROR FLAG
     LET AGE$ = ""                                   ! RESET AGED DATE
     IF STRIP(TRDAT$) = "" 
          LET AGE$ = "" 
          LET DATE8$ = ""
          LET TRDAT6$ = ""
          LET JDAT$ = ""
          GOTO CDRET       ! NO ENTRY MADE
     ENDIF
     IF LEN(TRDAT$) = 6 GOTO CDNODASH                ! SKIP AHEAD/NP '/'
     IF LEN(TRDAT$) = 8 AND POS(SUB(TRDAT$,3,1),'./-') = 0 GOTO CDNODASH
     IF POS(SUB(TRDAT$,3,1),'./-') = 0 GOTO CDERR    ! SLASH/DASH IN RIGHT POS
     IF POS(SUB(TRDAT$,6,1),'./-') = 0 GOTO CDERR    ! SLASH/DASH IN RIGHT POS
     LET AGE$ = SUB(TRDAT$,1,2)
         AGE$ = AGE$ + SUB(TRDAT$,4,2)
         AGE$ = AGE$ + SUB(TRDAT$,7,4)
         TRDAT$ = STRIPR(AGE$)
CDNODASH:         !CONVERT DATE TO CENTURY NUMBER
     GOSUB CDCENT                           !CONVERT TO NUMERIC CENT DATE
     IF DTERR = 1 GOTO CDERR                  !INVALID DATA
     GOSUB CDMDY                            !CONVERT TO MMDDCCYY
!
!      CONVERSION FROM MM/DD/CCYY TO CCYYJJJ
!         (MUST PROCESS CDMDY FIRST)
!
CDSETAGE:
     LET AGE$ = DTYR$ + MON$ + DOM$               ! AGING DATE YYYYMMDD
     LET TRDAT$ = MON$ + '/' + DOM$ + '/' + DTYR$ ! VALID DATE MM/DD/YYYY
         TEMPNUM = DATETONUM("0101"+DTYR$,DTERR)    !GET YEAR START DATE
         JDAY = ZDYCT - TEMPNUM + 1               !SET JULIAN DAYS
         JDOY$ = STR(JDAY)                        ! SET JULIAN DATE TO STR
         JDOY$ = STRIP(JDOY$)
         JDOY$ = SUB("000",1,3-LEN(JDOY$))+JDOY$  ! SET LEADING ZEROES
     LET JDAT$ = DTYR$ + JDOY$                    ! SET AS YYYYJJJ
CDRET:     
     RETURN                                         !<< NORMAL EXIT >>
!
CDERR:
     LET DTERR = 1                                      ! SET ERROR FLAG
     GOTO CDRET                                      !<< ERROR EXIT >>
!
!      CONVERSION FROM YYMMDD TO MM/DD/YY
!
CDAGE:
     LET DTERR = 0                                    !  SET ERROR FLAG TO OK
     LET AGE$ = STRIP(AGE$)
     IF AGE$ = "" 
          LET DATE8$ = ""
          LET TRDAT6$ = ""
          LET JDAT$ = ""
          LET TRDAT$ = "" 
          GOTO CDRET ! NO DATE TO CONVERT
     ENDIF
     IF LEN(AGE$) = 8
          LET TRDAT$ = SUB(AGE$,5,2) + '/'               ! SET MONTH
          LET TRDAT$ = TRDAT$ + SUB(AGE$,7,2) + '/'      ! SET DAY
          LET TRDAT$ = TRDAT$ + SUB(AGE$,1,4)            ! SET YEAR
     ELSE
          LET TRDAT$ = SUB(AGE$,3,2) + '/'               ! SET MONTH
          LET TRDAT$ = TRDAT$ + SUB(AGE$,5,2) + '/'      ! SET DAY
          LET TRDAT$ = TRDAT$ + SUB(AGE$,1,2)            ! SET YEAR
     ENDIF
          
     GOTO CKDATE
!
!      CONVERSION FROM CCYYJJJ TO MM/DD/CCYY
!
CDJUL:
     LET DTYR$ = SUB(JDAT$,1,4)                     ! SET JULIAN YEAR
         JDAY = NUM(SUB(JDAT$,5,3),DTERR)             ! GET DAYS OF THE YR
         TEMPNUM = DATETONUM("0101"+DTYR$,DTERR)      ! GET YEAR START DATE
         ZDYCT = TEMPNUM + JDAY - 1                 ! ADD DAYS OF THE YEAR
     GOSUB CDMDY                                     ! CONVERT TO MM/DD/YYYY
     LET MON$ = SUB(DATE8$,1,2)
         DOM$ = SUB(DATE8$,4,2)
         DTYR$ = SUB(DATE8$,7,4)
     GOTO CDSETAGE
!
!================== 6/8 BIT DATE TO CENTRY DATE CONVERSION ======================!
     !
CDCENT:
     LET ZDYCT = DATETONUM(TRDAT$,DTERR)         !CONVERT TO NUMERIC DATE
     ZDYWK = ZDYCT - INT(ZDYCT / 7.000) * 7 + 1
    RETURN
     !
!==============================================================================!
!========================= CENTURY DATE TO MM/DD/YYYY ==========================
     !
CDMDY:     
     LET TRDAT$ = NUMTODATE(ZDYCT)             !CONVERT BACK TO MMDDYYYY    
         MON$ = SUB(TRDAT$,1,2)                         ! MONTH DIGITS
         MON = NUM(MON$,DTERR)                        ! ...ARE THEY NUMERIC?
     IF DTERR = 1 GOTO CDERR                             ! ...NO:ERROR EXIT
     LET DOM$ = SUB(TRDAT$,3,2)                         ! DAY.OF.MTH DIGITS
         DY = NUM(DOM$,DTERR)                              ! ...ARE THEY NUMERIC?
     IF DTERR = 1 GOTO CDERR                             ! ...NO:ERROR EXIT
     LET DTYR$ = SUB(TRDAT$,5,4)                        ! YEAR DIGITS
     IF DTYR$ = '' OR DTYR$ = '    ' GOTO CDERR      ! ...CANNOT BE BLANK
     LET DTYR = NUM(DTYR$,DTERR)                            ! ...ARE THEY NUMERIC?
     IF DTERR = 1 GOTO CDERR                             ! ...NO:ERROR EXIT
     LET DATE8$ = MON$ + "/" + DOM$ + "/"
         DATE8$ = DATE8$ + DTYR$
         TRDAT6$ = MON$ + "/" + DOM$ + "/" +SUB(DTYR$,3,2)
     ZDYWK = ZDYCT - INT(ZDYCT / 7.000) * 7 + 1
     ! 
     RETURN
     
CDNUMDT:            !CONVERT FROM NUMERIC FIELDS
     LET DTYR$ = STR(DTYR)
         MON$ = STR(MON)
         IF MON < 10 LET MON$ = "0"+SUB(MON$,2,1)
         DOM$ = STR(DY)
         TRDAT$ = MON$ + DOM$ + DTYR$
     GOTO CDNODASH     
     !
!==============================================================================!
